// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"

#define PEK_TX_TECHLEVEL 2
#include "textfile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CDemoDlg dialog




CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_START, &CDemoDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &CDemoDlg::OnBnClickedStop)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoDlg::OnDestroy()
{
	CDialog::OnDestroy();

	OnBnClickedStop();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



// -------------------------------------------------------------------------------- //
//
// RunTimeTitleSDK usage
//  double crawl playback
//
// -------------------------------------------------------------------------------- //

// MinShowTime is time of playback "empty" area between crawls - time = width/(speed*fps)
const double g_fMinShowTime = 720.0 / (5.0 * 25.0);

#import "TitleSDK\SLTMTitleRunTime.tlb"

const CLSID CLSID_SLTMTitleServerTargetMgr = {0xDD02FC80,0x7D6E,0x440B,{0xBF,0x32,0x1A,0x29,0x77,0x4D,0xDC,0x1A}};
const CLSID CLSID_SLTMTitleNoPremultServerTargetMgr = {0xABCCE56A,0xC309,0x4FC8,{0x93,0x71,0x0F,0x58,0xCB,0xAA,0xAC,0x68}};
GUID guidTitleTarget = CLSID_SLTMTitleServerTargetMgr;

#define CHECK_RESULT(hres) { if( FAILED(hres) ) { ::MessageBox(NULL,_T("ERROR"),_T("Title Usage Error"),MB_OK);  return; } }

class CTitleProjectInfo {
public:
	SLTMTitleRunTime::ISLTMTitleRunTimeMgr2Ptr m_pIProject;
	SLTMTitleRunTime::ISLTMTitleRunTime3Ptr m_pICrawl[2];
	int m_nActiveIndex;
public:
	CTitleProjectInfo()
	{
		m_pIProject = NULL;
		m_pICrawl[0] = NULL;
		m_pICrawl[1] = NULL;
		m_nActiveIndex = 0;
		// load title project
		HRESULT hres = m_pIProject.CreateInstance(__uuidof(SLTMTitleRunTime::TitleProjectMgr));
		CHECK_RESULT(hres);
		CComBSTR bstrName(_T("C:\\Crawl2.SLTitleProj"));
		hres = m_pIProject->Init((BSTR)bstrName, 0, &guidTitleTarget);
		CHECK_RESULT(hres);
		// obtain pointers to crawls
		m_pICrawl[0] = m_pIProject->GetRunTimeInterface(0);
		m_pICrawl[1] = m_pIProject->GetRunTimeInterface(1);
		// active first line
		ActiveCrawl(0, 0.0);
	}
	~CTitleProjectInfo()
	{
		if( m_pICrawl[0] ) { m_pICrawl[0]->Abort(0);  m_pICrawl[0]=NULL; }
		if( m_pICrawl[1] ) { m_pICrawl[1]->Abort(0);  m_pICrawl[1]=NULL; }
		if( m_pIProject != NULL ) { m_pIProject->Uninit();  m_pIProject=NULL; }
	}
	void ActiveCrawl(int index, double time)
	{
		static int nCnt = 0;
		CTextFileWrite file(_T("C:\\Task.txt"), CTextFileBase::UNI16_BE);
		if( !file.IsOpen() ) { ::MessageBox(NULL,_T("ERROR"),_T("Title Usage Error"),MB_OK);  return; }
		CString str;  str.Format(_T("It is test text line for 2 crawl playback test. Text line number %d."),++nCnt);
		file.Write(str);
		file.Close();
		HRESULT hres = m_pICrawl[index]->LoadTask(_T("C:\\Task.txt"));
		CHECK_RESULT(hres);
		hres = m_pICrawl[index]->Start(time,0);
		CHECK_RESULT(hres);
		m_nActiveIndex = index;
	}
	void CheckTime()
	{
		// obtain rest playback time
		double fCurTime=0,fRestTime=0,tmp1;  long tmp2;
		HRESULT hres = m_pICrawl[m_nActiveIndex]->GetPlayInfo(&fCurTime, &fRestTime, &tmp1, &tmp2);
		CHECK_RESULT(hres);
		if( fRestTime < g_fMinShowTime+0.3 ) {
			double time = fCurTime + fRestTime - g_fMinShowTime;
			ActiveCrawl(m_nActiveIndex==0 ? 1 : 0, time);
		}
	}
};
static CTitleProjectInfo *info = NULL;
static UINT_PTR m_nTimerID = 0;

void CDemoDlg::OnBnClickedStart()
{
	if( info != NULL )  return;
	info = new CTitleProjectInfo();
	m_nTimerID = SetTimer(1,100,NULL);
}

void CDemoDlg::OnBnClickedStop()
{
	if( m_nTimerID != 0 ) { KillTimer(m_nTimerID);  m_nTimerID=0; }
	if( info != NULL ) { delete info;  info=NULL; }
}

void CDemoDlg::OnTimer(UINT_PTR nIDEvent)
{
	if( info != NULL )  info->CheckTime();
	CDialog::OnTimer(nIDEvent);
}
